]> git.madduck.net Git - code/myrepos.git/blobdiff - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Add webcheckout command. See http://kitenet.net/~joey/rfc/rel-vcs/
[code/myrepos.git] / mr
diff --git a/mr b/mr
index 2187aa06b59472cc9c13dfe5367bdd9b4ef59b45..182e6b3c1b93c0717c67a6dc8edaa9c242869bb1 100755 (executable)
--- a/mr
+++ b/mr
@@ -16,6 +16,8 @@ B<mr> [options] status
 
 B<mr> [options] commit [-m "message"]
 
+B<mr> [options] record [-m "message"]
+
 B<mr> [options] diff
 
 B<mr> [options] log
@@ -26,11 +28,15 @@ B<mr> [options] config section ["parameter=[value]" ...]
 
 B<mr> [options] action [params ...]
 
+B<mr> [options] [online|offline]
+
+B<mr> [options] remember action [params ...]
+
 =head1 DESCRIPTION
 
 B<mr> is a Multiple Repository management tool. It can checkout, update, or
 perform other actions on a set of repositories as if they were one combined
-respository. It supports any combination of subversion, git, cvs, mecurial,
+repository. It supports any combination of subversion, git, cvs, mecurial,
 bzr and darcs repositories, and support for other revision control systems can
 easily be added.
 
@@ -62,10 +68,24 @@ uncommitted changes are present in the repository.
 =item commit (or ci)
 
 Commits changes to each repository. (By default, changes are pushed to the
-remote repository too, when using distributed systems like git.)
+remote repository too, when using distributed systems like git. If you
+don't like this default, you can change it in your .mrconfig, or use record
+instead.)
+
+The optional -m parameter allows specifying a commit message.
+
+=item record
+
+Records changes to the local repository, but does not push them to the
+remote repository. Only supported for distributed revision control systems.
 
 The optional -m parameter allows specifying a commit message.
 
+=item push
+
+Pushes committed local changes to the remote repository. A no-op for
+centralized revision control systems.
+
 =item diff
 
 Show a diff of uncommitted changes.
@@ -115,14 +135,32 @@ To see the built-in library of shell functions contained in mr:
 The ~/.mrconfig file is used by default. To use a different config file,
 use the -c option.
 
+=item offline
+
+Advises mr that it is in offline mode. Any commands that fail in
+offline mode will be remembered, and retried when mr is told it's online.
+
+=item online
+
+Advices mr that it is in online mode again. Commands that failed while in
+offline mode will be re-run.
+
+=item remember
+
+Remember a command, to be run later when mr re-enters online mode. This
+implicitly puts mr into offline mode. The command can be any regular mr
+command. This is useful when you know that a command will fail due to being
+offline, and so don't want to run it right now at all, but just remember
+to run it when you go back online.
+
 =item help
 
 Displays this help.
 
 =back
 
-Actions can be abbreviated to any unambiguous subsctring, so
-"mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
+Actions can be abbreviated to any unambiguous substring, so
+"mr st" is equivalent to "mr status", and "mr up" is equivalent to "mr
 update"
 
 Additional parameters can be passed to most commands, and are passed on
@@ -147,26 +185,49 @@ Use the specified mrconfig file. The default is B<~/.mrconfig>
 
 Be verbose.
 
+=item -q
+
+Be quiet.
+
 =item -s
 
 Expand the statistics line displayed at the end to include information
 about exactly which repositories failed and were skipped, if any.
 
-=item -n
+=item -i
+
+Interactive mode. If a repository fails to be processed, a subshell will be
+started which you can use to resolve or investigate the problem. Exit the
+subshell to continue the mr run.
+
+=item -n [number]
 
-Just operate on the repository for the current directory, do not 
-recurse into deeper repositories.
+If no number if specified, just operate on the repository for the current
+directory, do not recurse into deeper repositories.
 
-=item -j number
+If a number is specified, will recurse into repositories at most that many
+subdirectories deep. For example, with -n 2 it would recurse into ./src/foo,
+but not ./src/packages/bar.
 
-Run the specified number of jobs in parallel. This can greatly speed up
-operations such as updates. It is not recommended for interactive
-operations.
+=item -j [number]
+
+Run the specified number of jobs in parallel, or an unlimited number of jobs
+with no number specified. This can greatly speed up operations such as updates.
+It is not recommended for interactive operations.
+
+Note that running more than 10 jobs at a time is likely to run afoul of
+ssh connection limits. Running between 3 and 5 jobs at a time will yeild
+a good speedup in updates without loading the machine too much.
 
 =back
 
 =head1 FILES
 
+The ~/.mrlog file contains commands that mr has remembered to run later,
+due to being offline. You can delete or edit this file to remove commands,
+or even to add other commands for 'mr online' to run. If the file is
+present, mr assumes it is in offline mode.
+
 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
 file in your home directory, and this can in turn chain load .mrconfig files
 from repositories.
@@ -195,7 +256,9 @@ is an alias, and its value is the action to use.
 All other sections add repositories. The section header specifies the
 directory where the repository is located. This is relative to the directory
 that contains the mrconfig file, but you can also choose to use absolute
-paths.
+paths. (Note that you can use environment variables in section names; they
+will be passed through the shell for expansion. For example, 
+"[$HOSTNAME]", or "[${HOSTNAME}foo]")
 
 Within a section, each parameter defines a shell command to run to handle a
 given action. mr contains default handlers for "update", "status",
@@ -232,7 +295,7 @@ mr is run by joey. The second uses the hours_since function
 (included in mr's built-in library) to skip updating the repo unless it's
 been at least 12 hours since the last update.
 
-  skip = test $(whoami) != joey
+  skip = test `whoami` != joey
   skip = [ "$1" = update ] && ! hours_since "$1" 12
 
 =item order
@@ -296,7 +359,8 @@ use warnings;
 use strict;
 use Getopt::Long;
 use Cwd qw(getcwd abs_path);
-use POSIX "WNOHANG";
+
+# things that can happen when mr runs a command
 use constant {
        OK => 0,
        FAILED => 1,
@@ -304,90 +368,35 @@ use constant {
        ABORT => 3,
 };
 
-$SIG{INT}=sub {
-       print STDERR "mr: interrupted\n";
-       exit 2;
-};
-
-$ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
+# configurables
 my $config_overridden=0;
 my $verbose=0;
+my $quiet=0;
 my $stats=0;
-my $no_recurse=0;
+my $interactive=0;
+my $max_depth;
 my $no_chdir=0;
 my $jobs=1;
+my $directory=getcwd();
+$ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
+
+# globals :-(
 my %config;
 my %configfiles;
 my %knownactions;
 my %alias;
-my $directory=getcwd();
 my (@ok, @failed, @skipped);
 
-getopts();
-
-# This can happen if it's run in a directory that was removed
-# or other strangeness.
-if (! defined $directory) {
-       die("mr: failed to determine working directory\n");
-}
-# Make sure MR_CONFIG is an absolute path, but don't use abs_path since
-# the config file might be a symlink to elsewhere, and the directory it's
-# in is significant.
-if ($ENV{MR_CONFIG} !~ /^\//) {
-       $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
-}
-# Try to set MR_PATH to the path to the program.
-eval {
-       use FindBin qw($Bin $Script);
-       $ENV{MR_PATH}=$Bin."/".$Script;
-};
-
-loadconfig(\*DATA);
-loadconfig($ENV{MR_CONFIG});
-#use Data::Dumper;
-#print Dumper(\%config);
-
-my $action=expandaction(shift @ARGV);
-dispatch($action);
-showstats($action);
-
-if (@failed) {
-       exit 1;
-}
-elsif (! @ok && @skipped) {
-       exit 1;
-}
-else {
-       exit 0;
-}
-
-sub dispatch { #{{{
-       my $action=shift;
-
-       # actions that do not operate on all repos
-       if ($action eq 'help') {
-               help(@ARGV);
-       }
-       elsif ($action eq 'config') {
-               config(@ARGV);
-       }
-       elsif ($action eq 'register') {
-               register(@ARGV);
-       }
-
-       if ($jobs > 1) {
-               mrs($action, selectrepos());
-       }
-       else {
-               foreach my $repo (selectrepos()) {
-                       record($repo, action($action, @$repo));
-               }
-       }
-} #}}}
+main();
 
+my %rcs;
 sub rcs_test { #{{{
        my ($action, $dir, $topdir, $subdir) = @_;
 
+       if (exists $rcs{$dir}) {
+               return $rcs{$dir};
+       }
+
        my $test="set -e\n";
        foreach my $rcs_test (
                        sort {
@@ -405,21 +414,30 @@ sub rcs_test { #{{{
        print "mr $action: running rcs test >>$test<<\n" if $verbose;
        my $rcs=`$test`;
        chomp $rcs;
-       if (! length $rcs) {
+       if ($rcs=~/\n/s) {
+               $rcs=~s/\n/, /g;
+               print STDERR "mr $action: found multiple possible repository types ($rcs) for $topdir$subdir\n";
                return undef;
        }
+       if (! length $rcs) {
+               return $rcs{$dir}=undef;
+       }
        else {
-               return $rcs;
+               return $rcs{$dir}=$rcs;
        }
 } #}}}
        
 sub findcommand { #{{{
-       my ($action, $dir, $topdir, $subdir) = @_;
+       my ($action, $dir, $topdir, $subdir, $is_checkout) = @_;
        
        if (exists $config{$topdir}{$subdir}{$action}) {
                return $config{$topdir}{$subdir}{$action};
        }
 
+       if ($is_checkout) {
+               return undef;
+       }
+
        my $rcs=rcs_test(@_);
 
        if (defined $rcs && 
@@ -433,23 +451,21 @@ sub findcommand { #{{{
 
 sub action { #{{{
        my ($action, $dir, $topdir, $subdir) = @_;
-
+       
        $ENV{MR_CONFIG}=$configfiles{$topdir};
        my $lib=exists $config{$topdir}{$subdir}{lib} ?
                       $config{$topdir}{$subdir}{lib}."\n" : "";
+       my $is_checkout=($action eq 'checkout');
 
-       if ($action eq 'checkout') {
+       $ENV{MR_REPO}=$dir;
+
+       if ($is_checkout) {
                if (-d $dir) {
                        print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
                        return SKIPPED;
                }
 
                $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
-
-               if (! -d $dir) {
-                       print "mr $action: creating parent directory $dir\n" if $verbose;
-                       system("mkdir", "-p", $dir);
-               }
        }
        elsif ($action =~ /update/) {
                if (! -d $dir) {
@@ -457,10 +473,8 @@ sub action { #{{{
                }
        }
 
-       $ENV{MR_REPO}=$dir;
-
-       my $skiptest=findcommand("skip", $dir, $topdir, $subdir);
-       my $command=findcommand($action, $dir, $topdir, $subdir);
+       my $skiptest=findcommand("skip", $dir, $topdir, $subdir, $is_checkout);
+       my $command=findcommand($action, $dir, $topdir, $subdir, $is_checkout);
 
        if (defined $skiptest) {
                my $test="set -e;".$lib.
@@ -482,7 +496,12 @@ sub action { #{{{
                        return SKIPPED;
                }
        }
-       
+
+       if ($is_checkout && ! -d $dir) {
+               print "mr $action: creating parent directory $dir\n" if $verbose;
+               system("mkdir", "-p", $dir);
+       }
+
        if (! $no_chdir && ! chdir($dir)) {
                print STDERR "mr $action: failed to chdir to $dir: $!\n";
                return FAILED;
@@ -494,18 +513,18 @@ sub action { #{{{
                        return FAILED;
                }
                else {
-                       print STDERR "mr $action: no defined $action command for $rcs repository $topdir$subdir, skipping\n";
+                       print STDERR "mr $action: no defined action for $rcs repository $topdir$subdir, skipping\n";
                        return SKIPPED;
                }
        }
        else {
                if (! $no_chdir) {
-                       print "mr $action: $topdir$subdir\n";
+                       print "mr $action: $topdir$subdir\n" unless $quiet;
                }
                else {
                        my $s=$directory;
                        $s=~s/^\Q$topdir$subdir\E\/?//;
-                       print "mr $action: $topdir$subdir (in subdir $s)\n";
+                       print "mr $action: $topdir$subdir (in subdir $s)\n" unless $quiet;
                }
                $command="set -e; ".$lib.
                        "my_action(){ $command\n }; my_action ".
@@ -524,6 +543,14 @@ sub action { #{{{
                        print STDERR "mr $action: failed ($ret)\n" if $verbose;
                        if ($ret >> 8 != 0) {
                                print STDERR "mr $action: command failed\n";
+                               if (-e "$ENV{HOME}/.mrlog" && $action ne 'remember') {
+                                       # recreate original command line to
+                                       # remember, and avoid recursing
+                                       my @orig=@ARGV;
+                                       @ARGV=('-n', $action, @orig);
+                                       action("remember", $dir, $topdir, $subdir);
+                                       @ARGV=@orig;
+                               }
                        }
                        elsif ($ret != 0) {
                                print STDERR "mr $action: command died ($ret)\n";
@@ -552,7 +579,7 @@ sub mrs { #{{{
        my @out;
        my $running=0;
        while (@fhs or @repos) {
-               while ($running < $jobs && @repos) {
+               while ((!$jobs || $running < $jobs) && @repos) {
                        $running++;
                        my $repo = shift @repos;
                        pipe(my $outfh, CHILD_STDOUT);
@@ -620,6 +647,11 @@ sub record { #{{{
                print "\n";
        }
        elsif ($ret == FAILED) {
+               if ($interactive) {
+                       chdir($dir) unless $no_chdir;
+                       print STDERR "mr: Starting interactive shell. Exit shell to continue.\n";
+                       system((getpwuid($<))[8]);
+               }
                push @failed, $dir;
                print "\n";
        }
@@ -635,6 +667,7 @@ sub record { #{{{
 } #}}}
 
 sub showstats { #{{{
+       my $action=shift;
        if (! @ok && ! @failed && ! @skipped) {
                die "mr $action: no repositories found to work on\n";
        }
@@ -642,10 +675,10 @@ sub showstats { #{{{
                showstat($#ok+1, "ok", "ok"),
                showstat($#failed+1, "failed", "failed"),
                showstat($#skipped+1, "skipped", "skipped"),
-       ).")\n";
+       ).")\n" unless $quiet;
        if ($stats) {
                if (@skipped) {
-                       print "mr $action: (skipped: ".join(" ", @skipped).")\n";
+                       print "mr $action: (skipped: ".join(" ", @skipped).")\n" unless $quiet;
                }
                if (@failed) {
                        print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
@@ -696,8 +729,13 @@ sub selectrepos { #{{{
                my $d=$directory;
                $dir.="/" unless $dir=~/\/$/;
                $d.="/" unless $d=~/\/$/;
-               next if $no_recurse && $d ne $dir;
                next if $dir ne $d && $dir !~ /^\Q$d\E/;
+               if (defined $max_depth) {
+                       my @a=split('/', $dir);
+                       my @b=split('/', $d);
+                       do { } while (@a && @b && shift(@a) eq shift(@b));
+                       next if @a > $max_depth || @b > $max_depth;
+               }
                push @repos, [$dir, $topdir, $subdir];
        }
        if (! @repos) {
@@ -721,6 +759,18 @@ sub selectrepos { #{{{
        return @repos;
 } #}}}
 
+sub expandenv { #{{{
+       my $val=shift;
+       
+
+       if ($val=~/\$/) {
+               $val=`echo "$val"`;
+               chomp $val;
+       }
+       
+       return $val;
+} #}}}
+
 my %loaded;
 sub loadconfig { #{{{
        my $f=shift;
@@ -781,7 +831,7 @@ sub loadconfig { #{{{
                chomp;
                next if /^\s*\#/ || /^\s*$/;
                if (/^\[([^\]]*)\]\s*$/) {
-                       $section=$1;
+                       $section=expandenv($1);
                }
                elsif (/^(\w+)\s*=\s*(.*)/) {
                        my $parameter=$1;
@@ -798,6 +848,9 @@ sub loadconfig { #{{{
                        if ($parameter eq "include") {
                                print "mr: including output of \"$value\"\n" if $verbose;
                                unshift @lines, `$value`;
+                               if ($?) {
+                                       print STDERR "mr: include command exited nonzero ($?)\n";
+                               }
                                next;
                        }
 
@@ -830,11 +883,11 @@ sub loadconfig { #{{{
                                        my $ret=system($value);
                                        if ($ret != 0) {
                                                if (($? & 127) == 2) {
-                                                       print STDERR "mr $action: chain test interrupted\n";
+                                                       print STDERR "mr: chain test interrupted\n";
                                                        exit 2;
                                                }
                                                elsif ($? & 127) {
-                                                       print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
+                                                       print STDERR "mr: chain test received signal ".($? & 127)."\n";
                                                }
                                        }
                                        else {
@@ -904,7 +957,7 @@ sub modifyconfig { #{{{
                                $addfields->();
                        }
 
-                       $section=$1;
+                       $section=expandenv($1);
 
                        push @out, $_;
                }
@@ -949,11 +1002,42 @@ sub modifyconfig { #{{{
        print $out @out;
        close $out;     
 } #}}}
-       
+
+sub dispatch { #{{{
+       my $action=shift;
+
+       # actions that do not operate on all repos
+       if ($action eq 'help') {
+               help(@ARGV);
+       }
+       elsif ($action eq 'config') {
+               config(@ARGV);
+       }
+       elsif ($action eq 'register') {
+               register(@ARGV);
+       }
+       elsif ($action eq 'remember' ||
+              $action eq 'offline' ||
+              $action eq 'online') {
+               my @repos=selectrepos;
+               action($action, @{$repos[0]}) if @repos;
+               exit 0;
+       }
+
+       if (!$jobs || $jobs > 1) {
+               mrs($action, selectrepos());
+       }
+       else {
+               foreach my $repo (selectrepos()) {
+                       record($repo, action($action, @$repo));
+               }
+       }
+} #}}}
+
 sub help { #{{{
-       exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
+       exec($config{''}{DEFAULT}{help}) || die "exec: $!";
 } #}}}
-       
+
 sub config { #{{{
        if (@_ < 2) {
                die "mr config: not enough parameters\n";
@@ -984,7 +1068,7 @@ sub config { #{{{
                                }
                        }
                        if (! $found) {
-                               die "mr $action: $section $_ not set\n";
+                               die "mr config: $section $_ not set\n";
                        }
                }
        }
@@ -993,37 +1077,47 @@ sub config { #{{{
 } #}}}
 
 sub register { #{{{
-       if (! $config_overridden) {
+       if ($config_overridden) {
+               # Find the directory that the specified config file is
+               # located in.
+               ($directory)=abs_path($ENV{MR_CONFIG})=~/^(.*\/)[^\/]+$/;
+       }
+       else {
                # Find the closest known mrconfig file to the current
                # directory.
                $directory.="/" unless $directory=~/\/$/;
+               my $foundconfig=0;
                foreach my $topdir (reverse sort keys %config) {
                        next unless length $topdir;
                        if ($directory=~/^\Q$topdir\E/) {
                                $ENV{MR_CONFIG}=$configfiles{$topdir};
                                $directory=$topdir;
+                               $foundconfig=1;
                                last;
                        }
                }
+               if (! $foundconfig) {
+                       $directory=""; # no config file, use builtin
+               }
        }
        if (@ARGV) {
                my $subdir=shift @ARGV;
                if (! chdir($subdir)) {
-                       print STDERR "mr $action: failed to chdir to $subdir: $!\n";
+                       print STDERR "mr register: failed to chdir to $subdir: $!\n";
                }
        }
 
        $ENV{MR_REPO}=getcwd();
-       my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT');
+       my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT', 0);
        if (! defined $command) {
-               die "mr $action: unknown repository type\n";
+               die "mr register: unknown repository type\n";
        }
 
        $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
        $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
                "my_action(){ $command\n }; my_action ".
                join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
-       print "mr $action: running >>$command<<\n" if $verbose;
+       print "mr register: running >>$command<<\n" if $verbose;
        exec($command) || die "exec: $!";
 } #}}}
 
@@ -1052,19 +1146,75 @@ sub expandaction { #{{{
 } #}}}
 
 sub getopts { #{{{
-       Getopt::Long::Configure("no_permute");
+       my @saved=@ARGV;
+       Getopt::Long::Configure("bundling", "no_permute");
        my $result=GetOptions(
                "d|directory=s" => sub { $directory=abs_path($_[1]) },
                "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
                "v|verbose" => \$verbose,
+               "q|quiet" => \$quiet,
                "s|stats" => \$stats,
-               "n|no-recurse" => \$no_recurse,
-               "j|jobs=i" => \$jobs,
+               "i|interactive" => \$interactive,
+               "n|no-recurse:i" => \$max_depth,
+               "j|jobs:i" => \$jobs,
        );
        if (! $result || @ARGV < 1) {
                die("Usage: mr [-d directory] action [params ...]\n".
                    "(Use mr help for man page.)\n");
        }
+       
+       $ENV{MR_SWITCHES}="";
+       foreach my $option (@saved) {
+               last if $option eq $ARGV[0];
+               $ENV{MR_SWITCHES}.="$option ";
+       }
+} #}}}
+
+sub init { #{{{
+       $SIG{INT}=sub {
+               print STDERR "mr: interrupted\n";
+               exit 2;
+       };
+       
+       # This can happen if it's run in a directory that was removed
+       # or other strangeness.
+       if (! defined $directory) {
+               die("mr: failed to determine working directory\n");
+       }
+       # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
+       # the config file might be a symlink to elsewhere, and the directory it's
+       # in is significant.
+       if ($ENV{MR_CONFIG} !~ /^\//) {
+               $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
+       }
+       # Try to set MR_PATH to the path to the program.
+       eval {
+               use FindBin qw($Bin $Script);
+               $ENV{MR_PATH}=$Bin."/".$Script;
+       };
+} #}}}
+
+sub main { #{{{
+       getopts();
+       init();
+
+       loadconfig(\*DATA);
+       loadconfig($ENV{MR_CONFIG});
+       #use Data::Dumper; print Dumper(\%config);
+       
+       my $action=expandaction(shift @ARGV);
+       dispatch($action);
+       showstats($action);
+
+       if (@failed) {
+               exit 1;
+       }
+       elsif (! @ok && @skipped) {
+               exit 1;
+       }
+       else {
+               exit 0;
+       }
 } #}}}
 
 # Finally, some useful actions that mr knows about by default.
@@ -1102,7 +1252,7 @@ lib =
                if [ -z "$flagfile" ]; then
                        error "cannot determine flag filename"
                fi
-               delta=$(perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile")
+               delta=`perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"`
                if [ "$delta" -lt "$2" ]; then
                        exit 0
                else
@@ -1120,10 +1270,10 @@ darcs_test = test -d "$MR_REPO"/_darcs
 git_bare_test =
        test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
        test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
-       test "$(GIT_CONFIG="$MR_REPO"/config git-config --get core.bare)" = true
+       test "`GIT_CONFIG="$MR_REPO"/config git config --get core.bare`" = true
 
 svn_update = svn update "$@"
-git_update = if [ "$@" ]; then git pull "$@"; else git pull -t origin master; fi
+git_update = git pull "$@"
 bzr_update = bzr merge "$@"
 cvs_update = cvs update "$@"
 hg_update  = hg pull "$@" && hg update "$@"
@@ -1134,21 +1284,33 @@ git_status = git status "$@" || true
 bzr_status = bzr status "$@"
 cvs_status = cvs status "$@"
 hg_status  = hg status "$@"
-darcs_status = darcs whatsnew -ls "$@"
+darcs_status = darcs whatsnew -ls "$@" || true
 
 svn_commit = svn commit "$@"
 git_commit = git commit -a "$@" && git push --all
 bzr_commit = bzr commit "$@" && bzr push
 cvs_commit = cvs commit "$@"
 hg_commit  = hg commit -m "$@" && hg push
-darcs_commit = darcs commit -a -m "$@" && darcs push -a
+darcs_commit = darcs record -a -m "$@" && darcs push -a
+
+git_record = git commit -a "$@"
+bzr_record = bzr commit "$@"
+hg_record  = hg commit -m "$@"
+darcs_record = darcs record -a -m "$@"
+
+svn_push = :
+git_push = git push "$@"
+bzr_push = bzr push "$@"
+cvs_push = :
+hg_push = hg push "$@"
+darcs_push = darcs push -a "$@"
 
 svn_diff = svn diff "$@"
 git_diff = git diff "$@"
 bzr_diff = bzr diff "$@"
 cvs_diff = cvs diff "$@"
 hg_diff  = hg diff "$@"
-darcs_diff = darcs diff "$@"
+darcs_diff = darcs diff -u "$@"
 
 svn_log = svn log "$@"
 git_log = git log "$@"
@@ -1159,44 +1321,44 @@ darcs_log = darcs changes "$@"
 git_bare_log = git log "$@"
 
 svn_register =
-       url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
+       url=`LC_ALL=C svn info . | grep -i '^URL:' | cut -d ' ' -f 2`
        if [ -z "$url" ]; then
                error "cannot determine svn url"
        fi
        echo "Registering svn url: $url in $MR_CONFIG"
        mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
 git_register = 
-       url="$(LANG=C git-config --get remote.origin.url)" || true
+       url="`LC_ALL=C git config --get remote.origin.url`" || true
        if [ -z "$url" ]; then
                error "cannot determine git url"
        fi
        echo "Registering git url: $url in $MR_CONFIG"
        mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
 bzr_register =
-       url=$(cat .bzr/branch/parent)
+       url="`LC_ALL=C bzr info . | egrep -i 'checkout of branch|parent branch' | awk '{print $NF}'`"
        if [ -z "$url" ]; then
                error "cannot determine bzr url"
        fi
        echo "Registering bzr url: $url in $MR_CONFIG"
        mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone '$url' '$MR_REPO'"
 cvs_register =
-       repo=$(cat CVS/Repository)
-       root=$(cat CVS/Root)
+       repo=`cat CVS/Repository`
+       root=`cat CVS/Root`
        if [ -z "$root" ]; then
                error "cannot determine cvs root"
                fi
        echo "Registering cvs repository $repo at root $root"
        mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
 hg_register = 
-       url=$(hg showconfig paths.default)
+       url=`hg showconfig paths.default`
        echo "Registering mercurial repo url: $url in $MR_CONFIG"
        mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
 darcs_register = 
-       url=$(cat _darcs/prefs/defaultrepo)
+       url=`cat _darcs/prefs/defaultrepo`
        echo "Registering darcs repository $url in $MR_CONFIG"
-       mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url'p '$MR_REPO'"
+       mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url' '$MR_REPO'"
 git_bare_register = 
-       url="$(LANG=C GIT_CONFIG=config git-config --get remote.origin.url)" || true
+       url="`LC_ALL=C GIT_CONFIG=config git config --get remote.origin.url`" || true
        if [ -z "$url" ]; then
                error "cannot determine git url"
        fi
@@ -1207,10 +1369,38 @@ help =
        if [ ! -e "$MR_PATH" ]; then
                error "cannot find program path"
        fi
-       (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
+       tmp=$(mktemp -t mr.XXXXXXXXXX) || error "mktemp failed"
+       trap "rm -f $tmp" exit
+       pod2man -c mr "$MR_PATH" > "$tmp" || error "pod2man failed"
+       man -l "$tmp" || error "man failed"
 list = true
 config = 
 
+online =
+       if [ -s ~/.mrlog ]; then
+               info "running offline commands"
+               mv -f ~/.mrlog ~/.mrlog.old
+               if ! sh -e ~/.mrlog.old; then
+                       error "offline command failed; left in ~/.mrlog.old"
+               fi
+               rm -f ~/.mrlog.old
+       else
+               info "no offline commands to run"
+       fi
+offline =
+       umask 077
+       touch ~/.mrlog
+       info "offline mode enabled"
+remember =
+       info "remembering command: 'mr $@'"
+       command="mr -d '$(pwd)' $MR_SWITCHES"
+       for w in "$@"; do
+               command="$command '$w'"
+       done
+       if [ ! -e ~/.mrlog ] || ! grep -q -F "$command" ~/.mrlog; then
+               echo "$command" >> ~/.mrlog
+       fi
+
 ed = echo "A horse is a horse, of course, of course.."
 T = echo "I pity the fool."
 right = echo "Not found."